
def readFile(filename):
    f=open(filename)
    struct=[]
    for row in f:
        if not row.startswith("FT"):
            continue
        data = row.split()
        if data[1] == 'STRAND' or data[1] == 'HELIX' or data[1] == 'TURN':
            struct.append((data[1],int(data[3])-int(data[2])+1))        
    return struct

def computeAverageLengths(struct):
    lengths={}
    num={}
    for (ss,length) in struct:
        if not lengths.has_key(ss):
            lengths[ss]=length
            num[ss]=1
        else:
            lengths[ss]+=length
            num[ss]+=1
    return normalize(lengths,num)

def computeAverageConsecutive(struct):
    durations={}
    num={}
    ss=struct[0][0]
    dur=1
    for i in range(1,len(struct)):
        if struct[i][0] == ss:
            dur+=1
        else:
            if not durations.has_key(ss):
                durations[ss] = dur
                num[ss]=1
            else:
                durations[ss] += dur
                num[ss]+=1
            ss=struct[i][0]    
            dur=1    
    durations[ss] += dur
    num[ss]+=1
    return normalize(durations,num)

def normalize(values,sizes):
    normvalues={}
    for (k,v) in values.items():
        normvalues[k] = float(values[k]) / sizes[k]
    return normvalues

def computeSecondaryStructureStats(filename):
    struct=readFile(filename)
    print "lunghezze medie"
    print computeAverageLengths(struct)
    print "occorrenze consecutive medie "
    print computeAverageConsecutive(struct)

filename=raw_input("Data file: ")
computeSecondaryStructureStats(filename)
